searchNodes=[{"doc":"","ref":"Bakeware.html","title":"Bakeware","type":"module"},{"doc":"Assembler function to be used as a Mix release stepThis will assemble the necessary components to create a Bakeware executable that can be distributed across machines to run the script/application without extra environment setup (such as installing Elixir/Erlang, etc)To use, add this to your release as a step after assembly:def release do [ demo: [ steps: [:assemble, &amp;Bakeware.assemble/1] ] ] end","ref":"Bakeware.html#assemble/1","title":"Bakeware.assemble/1","type":"function"},{"doc":"Helper to generate a script that takes command-line argumentsBakeware supports an API similar to Escript for implementing a main function.The main function will take 2 arguments:arg0 - The absolute path to the executableargs - Analogous to argv in other languages. A list or arguments passed to the executableThe main function must return a superset of functions that :erlang.halt/1 supports:integer -&gt; returning an integer will set the exit status. IE success: 0, error: &gt;= 1iodata -&gt; An Erlang crash dump is produced with iodata as slogan. Then the runtime system exits with status code 1. The string will be truncated if longer than 200 characters.:abort -&gt; The runtime system aborts producing a core dump, if that is enabled in the OS.Example:defmodule MyApp.Main do use Bakeware.Script @impl Bakeware.Script def main(_arg0, _args) do IO.puts &quot;Hello, World!&quot; 0 end end","ref":"Bakeware.Script.html","title":"Bakeware.Script","type":"behaviour"},{"doc":"Defines an app spec that will execute a script","ref":"Bakeware.Script.html#__using__/1","title":"Bakeware.Script.__using__/1","type":"macro"},{"doc":"","ref":"Bakeware.Script.html#get_argc!/0","title":"Bakeware.Script.get_argc!/0","type":"macro"},{"doc":"","ref":"Bakeware.Script.html#get_args/1","title":"Bakeware.Script.get_args/1","type":"macro"},{"doc":"","ref":"Bakeware.Script.html#c:main/1","title":"Bakeware.Script.main/1","type":"callback"},{"doc":"","ref":"Bakeware.Script.html#result_to_halt/1","title":"Bakeware.Script.result_to_halt/1","type":"macro"},{"doc":"","ref":"Bakeware.Script.html#t:args/0","title":"Bakeware.Script.args/0","type":"type"},{"doc":"","ref":"Mix.Tasks.Bakeware.Assemble.html","title":"Mix.Tasks.Bakeware.Assemble","type":"task"},{"doc":"Manually assemble bakeware executableGenerally, it is expected that you integrate assembly as a Mix release step (see Bakeware.assemble/1)However, this task provides the ability to manually assemble the Bakeware executable binary either for the current project, or for other specified release directories.Supported options:--name - Name to use for the binary. Defaults to the app name--path - path to release directory. Defaults to release directory of current Mix project","ref":"Mix.Tasks.Bakeware.Assemble.html#run/1","title":"Mix.Tasks.Bakeware.Assemble.run/1","type":"function"},{"doc":"Bakeware Compile Elixir applications into single, easily distributed executable binariesBakeware was made over a weekend at SpawnFest 2020 and thanks to the response from the community, we're working on finishing it off. While it's not ready for production, it's definitely ready for experimentation - just expect APIs to change in the near-term. If you'd like to help, please let us know and stay tuned!Bakeware extends Mix releases with the ability to turn Elixir projects into single binaries that can be copied and directly run. No need to install Erlang or untar files. The binaries look and feel like the build-products from other languages.Here's a quick list of features:Simple - add the bakeware dependency and the Bakeware assembler to your Mix release settingsSupports OSX and Linux (We wrote the code with Windows and the BSDs in mind, so support for those platforms may not be far off)Zstd compression for small binariesOptional support for automatic software updates (work in progress)Command-line argument passing conveniencesLots of examplesThis README contains the basics of making your applications work with Bakeware and reference material for when you need to dig into how it works.Since everything was written quickly and the integration is fairly straightforward, we recommend that you take a look at the examples. The examples are bare bones Elixir scripts, OTP applications, Phoenix applications and more with small changes to their mix.exs files and instructions for running that you can try out for yourself.","ref":"readme.html","title":"Bakeware","type":"extras"},{"doc":"Mix releaseBakeware supports tieing in executable binary assembly into a Mix release as a step by using the Bakeware.assemble/1 function.This will assemble the necessary components to create a Bakeware executable that can be distributed across machines to run the script/application without extra environment setup (such as installing Elixir/Erlang, etc)To use, add this to your release as a step after assembly:def release do [ demo: [ steps: [:assemble, &amp;Bakeware.assemble/1] ] ] endMix taskBakeware also supports manually assembling the executable via mix bakeware.assembleGenerally, it is expected that you integrate assembly as a Mix release step (see Bakeware.assemble/1)However, this task provides the ability to manually assemble the Bakeware executable binary either for the current project, or for other specified release directories.Supported options:--name - Name to use for the binary. Defaults to the app name--path - path to release directory. Defaults to release directory of current Mix project &lt;!-- ASSEMBLE_TASK !--&gt;ScriptingBakeware supports an API similar to Escript for implementing a main function.The main function will take 2 arguments:arg0 - The absolute path to the executableargs - Analogous to argv in other languages. A list or arguments passed to the executableThe main function must return a superset of functions that :erlang.halt/1 supports:integer -&gt; returning an integer will set the exit status. IE success: 0, error: &gt;= 1iodata -&gt; An Erlang crash dump is produced with iodata as slogan. Then the runtime system exits with status code 1. The string will be truncated if longer than 200 characters.:abort -&gt; The runtime system aborts producing a core dump, if that is enabled in the OS.Example:defmodule MyApp.Main do use Bakeware.Script @impl Bakeware.Script def main(_arg0, _args) do IO.puts &quot;Hello, World!&quot; 0 end end","ref":"readme.html#using","title":"Bakeware - Using","type":"extras"},{"doc":"Minimizing executable sizeBakeware binaries appear to have a lower bound of about 12 MB in size. We expect that they can be made smaller out-of-the-box, but here are a few things you can do:Make sure zstd is installed to enable compression during assembly:MacOS: brew install zstdUbuntu: apt-get install zstdBuild using MIX_ENV=prod. The default is MIX_ENV=dev, so be sure that the environment variable is set.Run rm -fr _build and then mix release. During development cruft builds up in the release directory. Bakeware can't tell the difference between the important files and the cruft, so executables will slowly grow in size if you don't do a clean build.Inspect your _build/prod/rel/&lt;name&gt; directory and especially under lib for files or dependencies that you might be including on accident.Make sure that compile-time dependencies are marked as runtime: false in your mix.exs so that they're not includedCreating cross-platform binariesBakeware binaries include the Erlang runtime but there are still dependencies on the host system. These include the C runtime and other libraries referenced by the Erlang runtime and any NIFs and ports in your application. Luckily, the binary ABIs of many libraries are very stable, but if distributing to a wide audience, it's useful to build on a system with older library versions. Python has a useful pointers in their packaging guides.","ref":"readme.html#tips","title":"Bakeware - Tips","type":"extras"},{"doc":"Command-line argumentsIn general, command-line arguments passed to Bakeware applications are passed through to Elixir. A few special command-line arguments can be passed to adjust the launchers behavior. Bakeware stops parsing command-line arguments when it encounters a --. Processed command-line arguments are not passed along to Elixir.The following arguments may be passed:--bw-info - Print out information about the application--bw-gc - This cleans up all unused entries in the cache (NOT IMPLEMENTED)--bw-install - Do not run the application. Stop after installing to the cache directory. (NOT IMPLEMENTED)--bw-system-install - Install to a system-wide location (NOT IMPLEMENTED)Environment variablesThe Bakeware launcher sets the following environment variables for use in Elixir:Variable nameDescriptionBAKEWARE_EXECUTABLEThe absolute path to the executableBAKEWARE_ARG1The first command-line argumentBAKEWARE_ARGnThe nth command-line argumentBAKEWARE_ARGCThe number of argumentsSee the Scripting section of this document for a more user friendly API.Binary formatBakeware application binaries look like this:Bakeware application launcherA CPIO archive of an Erlang/OTP releaseTrailerThe CPIO archive can be compressed. This depends on the contents of the trailer.Trailer format (multi-byte fields are big endian):Offset from endFieldTypeDescription-4Magic4 byte stringSet to &quot;BAKE&quot;-5Trailer version8-bit integerSet to 1-6Compression8-bit integer0 = No compression, 1 = Zstd-8Flags16-bit integerSet to 0 (no flags yet)-12Contents offset32-bit integerOffset of CPIO archive-16Contents length32-bit integerLength of CPIO archive-48SHA25632 bytesSHA-256 of the CPIO archive","ref":"readme.html#reference-material","title":"Bakeware - Reference material","type":"extras"},{"doc":"Bakeware maintains a cache of extracted binaries. This is needed to run the OTP releases and it enables start-time optimizations.The cache directory location is system-specific:Windows - &quot;C:/Users/&lt;USER&gt;/AppData/Local/Bakeware/cache&quot;MacOS - &quot;~/Library/Caches/Bakeware&quot;Linux and other Unixes - &quot;~/.cache/bakeware&quot;Here's the layout of each cache entry:PathCreated byDescription$CACHE_DIR/$SHA256/source_pathsLauncherA list of source paths (used for GC)$CACHE_DIR/$SHA256/binCPIOOTP release's bin directory$CACHE_DIR/$SHA256/erts-x.y.zCPIOOTP release's ERTS$CACHE_DIR/$SHA256/libCPIOOTP release's lib directory$CACHE_DIR/$SHA256/releasesCPIOOTP release's releases directory$CACHE_DIR/$SHA256/startCPIOStart script. E.g., bin/my_otp_release startTODO: Add lock file to protect an executable being extracted on top of itself. This might actually work, though...","ref":"readme.html#cache-directory","title":"Bakeware - Cache directory","type":"extras"},{"doc":"All code is licensed under Apache-2.0 with the exception of zstd which is dual licensed BSD/GPL. See it's LICENSE and COPYING files for more details.","ref":"readme.html#license","title":"Bakeware - LICENSE","type":"extras"},{"doc":"Changelog","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"Bug fixes:Fix script startup crash when testing locally (#66)","ref":"changelog.html#v0-1-2","title":"Changelog - v0.1.2","type":"extras"},{"doc":"Initial release to hex.This release is ok for experimentation, but it not intended for production use. It has known issues with script and extraction cache handling.","ref":"changelog.html#v0-1-1","title":"Changelog - v0.1.1","type":"extras"}]